Attribute VB_Name = "Module1"
Option Explicit
Global Const KEY_DOWN As Integer = &H1000
Global Const SND_ASYNC = &H1, SND_NOSTOP = &H10

' *** Map Constant
Global Const AMKT = 0
Global Const MALANG = 1
Global Const DELLY = 2
Global Const ROAD = 3
Global Const STONE = 4
Global Const SNOW = 5
Global Const POLICE = 6
Global Const FOREST = 7
Global Const SURABAYA = 8
Global Const DOLLY = 9
Global Const BALIKPAPAN = 10
Global Const SAMARINDA = 11
Global Const MANSION = 12
Global Const GOVERNOR = 13
Global Const TARAKAN = 14
Global Const TRAIN = 15
Global Const NUNUKAN = 16
Global Const BERAU = 17

' *** music code
Global Const WORLD_MS As Byte = 0
Global Const WAR0_MS As Byte = 1
Global Const WAR1_MS As Byte = 2
Global Const WAR2_MS As Byte = 3
Global Const WAR3_MS As Byte = 4
Global Const WAR4_MS As Byte = 5
Global Const WAR5_MS As Byte = 6

' *** Sound Code
Global Const PUNCH_SND = 0
Global Const DEATH2_SND = 1
Global Const CURE_SND = 2
Global Const POWERUP_SND = 3
Global Const RUDRA_SND = 4
Global Const ICEBREAK_SND = 5
Global Const ICEDROP_SND = 6
Global Const THUNDER_SND = 7
Global Const SWORD_SND = 8
Global Const HFIRE_SND = 9
Global Const SALAMANDER_SND = 10
Global Const GEYSER_SND = 11
Global Const ARMAGEDDON_SND = 12
Global Const SCREAM_SND = 13

' Battle Situation
Global Const PUNKER = 0
Global Const WIWIT = 1
Global Const TRI = 2
Global Const SUPERMAN = 3
Global Const BATMAN = 4
Global Const TIMON = 5

' ** Face constant
Global Const ACTOR_FACE = 0
Global Const SIMON_FACE = 1
Global Const WIWIT_FACE = 2
Global Const DELLY_FACE = 3
Global Const SAMSUL_FACE = 4
Global Const SUBHAN_FACE = 5
Global Const AGUS_FACE = 6
Global Const YUDHI_FACE = 7
Global Const TRI_FACE = 8

' ** DirectX !!!
Global dx As New DirectX7
' *** DirectSound
Global Ds As DirectSound
Global DsBuffer As DirectSoundBuffer
Global DsDesc As DSBUFFERDESC
Global DsWave As WAVEFORMATEX
' **** DirectMusic
Global perf As DirectMusicPerformance
Global seg As DirectMusicSegment
Global segstate As DirectMusicSegmentState
Global loader As DirectMusicLoader

Global p233class As Boolean

' ** Battle Requirement
Global double_num As Integer
Global triple_num As Integer
Global shield_num As Integer
Global cure_num As Integer
Global card_maxvalue As Integer, card_minvalue As Integer
Global maxhp

Global gold As Integer
Global Battle_situation
Global Current_Map As Integer
Global lname As String

' Event Trigger
Global SIMON_EVENT As Boolean
Global DELLY_EVENT As Boolean
Global PUNKER_EVENT As Boolean
Global PUNK_EVENT As Boolean
Global SNOW_EVENT As Boolean
Global DELLY_EVENT2 As Boolean

Global SIMON_EVENT2 As Boolean
Global POLICE_EVENT As Boolean
Global WIWIT_EVENT As Boolean
Global POLICE_EVENT2 As Boolean
Global DOLLY_EVENT As Boolean
Global POLICE_EVENT3 As Boolean

Global AGUS_EVENT As Boolean
Global GOVERNOR_EVENT As Boolean
Global FOREST_EVENT As Boolean
Global ROBBER_EVENT As Boolean

Global SIMON_EVENT3 As Boolean

Declare Function GetTickCount Lib "kernel32" () As Long

Declare Function GetKeyState Lib "user32" (ByVal nVirtKey As Long) As Integer

'*** BitBlock Transfer
Declare Function BitBlt Lib "gdi32" _
                (ByVal hDestDC As Long, _
                 ByVal X As Long, _
                 ByVal Y As Long, _
                 ByVal nWidth As Long, _
                 ByVal nHeight As Long, _
                 ByVal hSrcDC As Long, _
                 ByVal xsrc As Long, _
                 ByVal ySrc As Long, _
                 ByVal dwRop As Long) As Long
                 
Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, _
ByVal X As Long, ByVal Y As Long, _
ByVal nWidth As Long, ByVal nHeight As Long, _
ByVal hSrcDC As Long, ByVal xsrc As Long, _
ByVal ySrc As Long, ByVal nSrcWidth As Long, _
ByVal nSrcHeight As Long, ByVal dwRop As Long _
) As Long
                 
Sub delay(wait As Long)
Dim lasttick As Long
Dim currenttick As Long
  
If p233class = False And wait < 30 And wait > 9 Then wait = wait + 20
  
  lasttick = GetTickCount
  
  Do
  currenttick = GetTickCount
  DoEvents
  Loop Until ((currenttick - lasttick) > wait)
  
End Sub
Sub init_sound()
Set Ds = dx.DirectSoundCreate("")

DsDesc.lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
DsWave.nFormatTag = WAVE_FORMAT_PCM
DsWave.nChannels = 2
DsWave.lSamplesPerSec = 22050
DsWave.nBitsPerSample = 16
DsWave.nBlockAlign = DsWave.nBitsPerSample / 8 * DsWave.nChannels
DsWave.lAvgBytesPerSec = DsWave.lSamplesPerSec * DsWave.nBlockAlign

End Sub
Sub init_music()

Set loader = dx.DirectMusicLoaderCreate()

Set perf = dx.DirectMusicPerformanceCreate()

Call perf.Init(Nothing, 0)

' ** Standard port
perf.SetPort -1, 80
Call perf.SetMasterAutoDownload(True)
' ** The volume 0-100%, we have 75% to understand the formula
perf.SetMasterVolume (75 * 42 - 3000)

End Sub
Sub sound(i As Integer)
Dim filename As String

Select Case i
 Case PUNCH_SND
  filename = App.Path & "\se\punch.wav"
 Case DEATH2_SND
  filename = App.Path & "\se\death2.wav"
 Case CURE_SND
  filename = App.Path & "\se\cure.wav"
 Case POWERUP_SND
  filename = App.Path & "\se\powerup.wav"
 Case RUDRA_SND
  filename = App.Path & "\se\rudra.wav"
 Case ICEBREAK_SND
  filename = App.Path & "\se\icebreak.wav"
 Case ICEDROP_SND
  filename = App.Path & "\se\icedrop.wav"
 Case THUNDER_SND
  filename = App.Path & "\se\thunder.wav"
 Case SWORD_SND
  filename = App.Path & "\se\sword.wav"
 Case HFIRE_SND
  filename = App.Path & "\se\hfire.wav"
 Case SALAMANDER_SND
  filename = App.Path & "\se\salamander.wav"
 Case GEYSER_SND
  filename = App.Path & "\se\geyser.wav"
 Case ARMAGEDDON_SND
  filename = App.Path & "\se\armageddon.wav"
 Case SCREAM_SND
  filename = App.Path & "\se\scream.wav"
End Select

Set DsBuffer = Ds.CreateSoundBufferFromFile(filename, DsDesc, DsWave)

DsBuffer.Play DSBPLAY_DEFAULT

End Sub
Sub ServiceBackgroundMusic()

If perf.IsPlaying(seg, segstate) = False Then
   Set segstate = perf.PlaySegment(seg, 0, 0)
End If

End Sub
Sub Backgroundmusic(i As Byte)

Dim filename As String

Select Case i
 Case WORLD_MS
  filename = App.Path & "\Music\world.mid"
  
 Case WAR0_MS
  filename = App.Path & "\Music\war0.mid"

 Case WAR1_MS
  filename = App.Path & "\Music\war1.mid"
 
 Case WAR2_MS
  filename = App.Path & "\Music\war2.mid"
 
 Case WAR3_MS
  filename = App.Path & "\Music\war3.mid"
 
 Case WAR4_MS
  filename = App.Path & "\Music\war4.mid"
 
 Case WAR5_MS
  filename = App.Path & "\Music\war5.mid"
End Select

' ** Load the MIDI and set it to Segment
Set seg = loader.LoadSegment(filename)
seg.SetStandardMidiFile

Set segstate = perf.PlaySegment(seg, 0, 0)

End Sub
Sub StopBGM()

Call perf.Stop(seg, segstate, 0, 0)

End Sub
Sub stop_DIRECTX()

'*** DirectMusic
Call perf.Stop(seg, segstate, 0, 0)
If Not (perf Is Nothing) Then perf.CloseDown

End Sub

